import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
import AtomImage from '@s-ui/react-atom-image';
import cx from 'classnames';
var BASE_CLASS = 'sui-MoleculeThumbnail';
var CAPTION_CLASS = BASE_CLASS + "-caption";
var LINK_CLASS = BASE_CLASS + "-link";
var CONTAINER_IMAGE = BASE_CLASS + "-containerImage";
var SIZES = {
  LARGE: 'large',
  MEDIUM: 'medium',
  SMALL: 'small',
  XSMALL: 'xsmall'
};
var RATIOS = {
  '1:1': '1-1',
  '4:3': '4-3',
  '16:9': '16-9'
};
var SHAPES = {
  SQUARED: 'squared',
  CIRCLED: 'circled'
};

var MoleculeThumbnail = function MoleculeThumbnail(props) {
  var href = props.href,
      size = props.size,
      ratio = props.ratio,
      shape = props.shape,
      target = props.target,
      captionText = props.captionText,
      Link = props.linkFactory,
      propsImage = _objectWithoutPropertiesLoose(props, ["href", "size", "ratio", "shape", "target", "captionText", "linkFactory"]);

  var ImageCaption = function ImageCaption() {
    return /*#__PURE__*/_jsxs("div", {
      children: [/*#__PURE__*/_jsx("div", {
        className: cx("" + CONTAINER_IMAGE, CONTAINER_IMAGE + "--" + ratio),
        children: /*#__PURE__*/_jsx(AtomImage, _extends({}, propsImage))
      }), captionText && /*#__PURE__*/_jsx("figcaption", {
        className: CAPTION_CLASS,
        children: captionText
      })]
    });
  };

  return /*#__PURE__*/_jsx("figure", {
    className: cx("" + BASE_CLASS, BASE_CLASS + "--" + size, BASE_CLASS + "--" + shape),
    children: href ? /*#__PURE__*/_jsx(Link, {
      className: LINK_CLASS,
      href: href,
      target: target,
      rel: target === '_blank' && 'noopener',
      children: /*#__PURE__*/_jsx(ImageCaption, {})
    }) : /*#__PURE__*/_jsx(ImageCaption, {})
  });
};

MoleculeThumbnail.displayName = 'MoleculeThumbnail';
MoleculeThumbnail.defaultProps = {
  target: '_blank',
  size: SIZES.MEDIUM,
  shape: SHAPES.SQUARED,
  ratio: RATIOS['1:1'],
  // eslint-disable-next-line react/prop-types
  linkFactory: function linkFactory(_temp) {
    var _ref = _temp === void 0 ? {} : _temp,
        children = _ref.children,
        rest = _objectWithoutPropertiesLoose(_ref, ["children"]);

    return /*#__PURE__*/_jsx("a", _extends({}, rest, {
      children: children
    }));
  }
};
export default MoleculeThumbnail;
export { SIZES as moleculeThumbnailSize, RATIOS as moleculeThumbnailRatio, SHAPES as moleculeThumbnailShape };